package com.xhkjedu.sapi.controller.appversion;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.annotation.Action;
import com.xhkjedu.sapi.model.appversion.TAppTeacherclient;
import com.xhkjedu.sapi.service.appversion.AppTeacherclientService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import com.xhkjedu.sapi.vo.appversion.AppversionVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author ywx
 * @classname AppTeacherclientController
 * @description 
 * @date 2020/7/23 16:40
 **/
@RestController
@RequestMapping("/appclient")
public class AppTeacherclientController {
    @Resource
    private AppTeacherclientService appTeacherclientService;

    @PostMapping("/add")
    @Action("教师手机端-增加")
    public ResultVo add(@RequestBody TAppTeacherclient appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionname(),"版本名称",2,
                appclient.getVersioncode(),"版本号",2,appclient.getVersionpath(),"应用文件",2});
        Integer id = appTeacherclientService.save(appclient);
        return new ResultVo(0, "保存成功",id);
    }

    @PostMapping("/delete")
    @Action("教师手机端-删除")
    public ResultVo delete(@RequestBody TAppTeacherclient appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appTeacherclientService.deleteById(appclient.getVersionid());
        return new ResultVo(0,"删除成功");
    }

    @PostMapping("/update")
    @Action("教师手机端-修改")
    public ResultVo update(@RequestBody TAppTeacherclient appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appTeacherclientService.update(appclient);
        return new ResultVo(0,"修改成功");
    }

    @PostMapping("/detail")
    public ResultVo detail(@RequestBody TAppTeacherclient appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        TAppTeacherclient client = appTeacherclientService.findById(appclient.getVersionid());
        return new ResultVo(0,"获取详情成功",client);
    }

    @PostMapping("/list")
    public ResultVo list(@RequestBody TAppTeacherclient appclient) {
        PageHelper.startPage(appclient.getPage(), appclient.getPageSize());
        List<AppversionVo> list = appTeacherclientService.listAll();
        PageResult pageResult = PageUtil.getPageResult(new PageInfo(list));
        return new ResultVo(0,"获取app版本列表成功",pageResult);
    }

    @PostMapping("/get_new")
    public ResultVo getNew() {
        TAppTeacherclient appclient = appTeacherclientService.getNew();
        return new ResultVo(0,"获取最新app版本成功",appclient);
    }
}
